<?php

    lt_include(PLOG_CLASS_PATH."class/action/admin/adminaction.class.php");
    lt_include(PLOG_CLASS_PATH."plugins/subscribe/class/view/pluginsubscribeshowconfigview.class.php");
    lt_include(PLOG_CLASS_PATH."plugins/subscribe/class/dao/subscriptions.class.php");
    lt_include(PLOG_CLASS_PATH."class/config/config.class.php");
    lt_include(PLOG_CLASS_PATH."class/view/admin/adminerrorview.class.php");
    lt_include(PLOG_CLASS_PATH."class/data/validator/integervalidator.class.php");

    class PluginSubscribeUpdateConfigAction extends AdminAction
    {
        var $_pluginEnabled;
        var $_key;
        
        function PluginSubscribeUpdateConfigAction($actionInfo, $request){
            $this->AdminAction( $actionInfo, $request );
        }

        function validate(){
            $this->_pluginEnabled = $this->_request->getValue("pluginEnabled");
            $this->_pluginEnabled = ($this->_pluginEnabled != "");

            $this->_key = $this->_request->getValue( "key" );
/*            if( $this->_key == "" ) {
                $this->_view = new PluginSubscribeShowConfigView( $this->_blogInfo );
                $this->_view->setErrorMessage( $this->_locale->tr("subscribe_error_key"));
                $this->setCommonData();
                return false;
            }
*/          
            return true;
        }            
        
		function perform(){
                // update the plugin configurations to blog setting
			$blogSettings = $this->_blogInfo->getSettings();

            $oldKey = $blogSettings->getValue("plugin_subscribe_key");
            $oldEnabled = $blogSettings->getValue("plugin_subscribe_enabled");

            $blogSettings->setValue("plugin_subscribe_enabled", $this->_pluginEnabled);
            $blogSettings->setValue("plugin_subscribe_key", $this->_key);
            $this->_blogInfo->setSettings( $blogSettings ); 
                        
                // save the blog's settings
			$blogs = new Blogs();
            if( !$blogs->updateBlog( $this->_blogInfo )) {
                $this->_view = new PluginSubscribeShowConfigView( $this->_blogInfo );
                $this->_view->setErrorMessage( $this->_locale->tr("error_updating_settings"));
                $this->setCommonData();

                return false;
            }
			
			// if everything went ok...
            $this->_session->setValue( "blogInfo", $this->_blogInfo );
            $this->saveSession();
			
			$this->_view = new PluginSubscribeShowConfigView($this->_blogInfo);
			$this->_view->setSuccessMessage( $this->_locale->tr("subscribe_settings_saved_ok"));
			$this->setCommonData();
			
			// clear the cache and reset confirmation codes if something changed
            if(($oldKey != $this->_key) || ($oldEnabled != $this->_pluginEnabled)){
                Subscriptions::resetConfirmationCodes($this->_blogInfo);
                CacheControl::resetBlogCache($this->_blogInfo->getId());
            }
            
            return true;		
        }
    }
?>